;; This NICKSHOUSE Lisp function was created automatically from 
;; the NICKSHOUSE.SCR script file using the CALSCRIPT->LISP
;; command or the COMPILESCRIPT command. Only the anonymous LAMBDA
;; has been replaced by DEFUN NICKSHOUSE, and the C:NICKSHOUSE
;; function which asks the user for an insertion point, the  
;; insertion angle and the WIDTH and HEIGHT properties is added.
;; Simply load this file into AutoCAD or BricsCAD, load CADCAL,
;; and call the NICKSHOUSE command. It will create a CALSCRIPT
;; object which can be modified using the CC-MODIFY command.
;; You can move, rotate, or copy these CALSCRIPT objects, and 
;; they will still be editable. And they keep all user defined 
;; properties including XDATA and XDICTIONARIES. CC-MODIFY keeps 
;; entity name and refhandle intact.

(defun nickshouse	(WIDTH	    HEIGHT     /	  OLDCMDECHO LISPLIST
	 RESULT	    IMPORTDATA _BYBLOCK	  BYBLOCK    _BYLAYER
	 BYLAYER    CC:IMPORT  P1	  P2	     P3
	 P4	    ROOFX      ROOFY	  ROOFPT     NEWSSET
	 LASTENT    LST	       CC:LAMBDAFUNCTION
	)
  (SETQ	CC:LAMBDAFUNCTION
	 '((WIDTH     HEIGHT	/	  OLDCMDECHO	      LISPLIST
	    RESULT    IMPORTDATA	  _BYBLOCK  BYBLOCK   _BYLAYER
	    BYLAYER   CC:IMPORT	P1	  P2	    P3	      P4
	    ROOFX     ROOFY	ROOFPT	  NEWSSET   LASTENT   LST
	   )
	   (SETQ OLDCMDECHO (GETVAR "CMDECHO"))
	   (SETVAR "CMDECHO" 0)
	   (SETQ CALSCRIPT:VERSION "2024 JUNE 30 BETA")
	   (SETQ
	    IMPORTDATA
	    (LIST '(WIDTH 100) '(HEIGHT 100))
	   )
	   (SETQ LASTENT (ENTLAST))
	   (IF
	    (NOT ORIGIN)
	    (SETQ ORIGIN (LIST 0 0 0))
	   )
	   (CC-LAMBDACORE
	    '((SETQ P1 ORIGIN)
	      (SETQ P2 (+ (LIST P1 (LIST WIDTH 0))))
	      (SETQ P3 (+ (LIST P1 (LIST WIDTH HEIGHT))))
	      (SETQ P4 (+ (LIST P1 (LIST 0 HEIGHT))))
	      (SETQ
	       ROOFX
	       (+ (LIST (RXOF (LIST P1)) (/ WIDTH 2)))
	      )
	      (SETQ
	       ROOFY
	       (+ (LIST (RYOF (LIST P1)) (* HEIGHT 2)))
	      )
	      (SETQ ROOFPT (LIST ROOFX ROOFY))
	      (PLINE (LIST P1 P2 P3 ROOFPT P4 P3 P1 P4 P2))
	     )
	   )
	   (IF
	    (AND
	     (SETQ NEWSSET (CC-NEWSET LASTENT))
	     (/= 0 CC:BLOCKIFY)
	    )
	    (PROGN
	     (OR
	      (AND ORIGIN (CC-ISPOINT ORIGIN))
	      (NOT
	       (PRINC
		"\nCC message: Script has not set ORIGIN, setting ORIGIN to [0,0,0]"
	       )
	      )
	      (SETQ ORIGIN '(0 0 0))
	     )
	     (IF
	      (SETQ
	       BLOCK-EN
	       (CC-MAKEBLOCK NEWSSET ORIGIN "*A" CC:OLDBLOCKNAME)
	      )
	      (PROGN
	       (IF
		CC:INSERTIONANGLE
		(CC-MODENT BLOCK-EN 50 CC:INSERTIONANGLE)
	       )
	       (XDATA-PUT
		BLOCK-EN
		"CALSCRIPT"
		(LIST
		 (LIST
		  "DATA"
		  (MAPCAR
		   '(LAMBDA (DAT) (LIST (CAR DAT) (EVAL (CAR DAT))))
		   IMPORTDATA
		  )
		 )
		 (LIST "CALSCRIPT:VERSION" CALSCRIPT:VERSION)
		 (LIST "SCRIPTMODE" "COMPILED")
		 (LIST "SCRIPTFILE" CC:FILENAME)
		 (LIST "SCRIPTFILEDATE" CC:SCRIPTFILEDATE)
		 (LIST "COMPILEDATE" CC:COMPILEDATE)
		 (LIST "COMPILEDBY" CC:COMPILEDBY)
		 (LIST
		  "BLOCKMAKEDATE"
		  (CC-RTOS (GETVAR "cdate") 2 6)
		 )
		 (LIST "WORKSTID" (GETENV "WORKSTID"))
		 (LIST "USER" (GETENV "user"))
		)
	       )
	       (XDICTIONARY-PUT
		BLOCK-EN
		"CALSCRIPT"
		(LIST
		 (LIST "SCRIPT" LINELIST)
		 (LIST "LAMBDA" CC:LAMBDAFUNCTION)
		)
	       )
	       (LIST BLOCK-EN)
	      )
	     )
	    )
	    (CC-NEWSET LASTENT)
	   )
	  )
  )
  (SETQ OLDCMDECHO (GETVAR "CMDECHO"))
  (SETVAR "CMDECHO" 0)
  (SETQ CALSCRIPT:VERSION "2024 JUNE 12 BETA")
  (SETQ IMPORTDATA (LIST '(WIDTH 100) '(HEIGHT 100)))
  (SETQ LASTENT (ENTLAST))
  (IF (NOT ORIGIN)
    (SETQ ORIGIN (LIST 0 0 0))
  )
  (CC-LAMBDACORE
    '((SETQ P1 ORIGIN)
      (SETQ P2 (+ (LIST P1 (LIST WIDTH 0))))
      (SETQ P3 (+ (LIST P1 (LIST WIDTH HEIGHT))))
      (SETQ P4 (+ (LIST P1 (LIST 0 HEIGHT))))
      (SETQ ROOFX (+ (LIST (RXOF (LIST P1)) (/ WIDTH 2))))
      (SETQ ROOFY (+ (LIST (RYOF (LIST P1)) (* HEIGHT 2))))
      (SETQ ROOFPT (LIST ROOFX ROOFY))
      (PLINE (LIST P1 P2 P3 ROOFPT P4 P3 P1 P4 P2))
     )
  )
  (IF (AND (SETQ NEWSSET (CC-NEWSET LASTENT)) (/= 0 CC:BLOCKIFY))
    (PROGN
      (OR
	(AND ORIGIN (CC-ISPOINT ORIGIN))
	(NOT
	  (PRINC
	    "\nCC message: Script has not set ORIGIN, setting ORIGIN to [0,0,0]"
	  )
	)
	(SETQ ORIGIN '(0 0 0))
      )
      (IF (SETQ
	    BLOCK-EN (CC-MAKEBLOCK NEWSSET ORIGIN "*A" CC:OLDBLOCKNAME)
	  )
	(PROGN
	  (IF CC:INSERTIONANGLE
	    (CC-MODENT BLOCK-EN 50 CC:INSERTIONANGLE)
	  )
	  (XDATA-PUT
	    BLOCK-EN
	    "CALSCRIPT"
	    (LIST
	      (LIST
		"DATA"
		(MAPCAR	'(LAMBDA (DAT) (LIST (CAR DAT) (EVAL (CAR DAT))))
			IMPORTDATA
		)
	      )
	      (LIST "CALSCRIPT:VERSION" CALSCRIPT:VERSION)
	      (LIST "SCRIPTMODE" "COMPILED")
	      (LIST "SCRIPTFILE" CC:FILENAME)
	      (LIST "SCRIPTFILEDATE" CC:SCRIPTFILEDATE)
	      (LIST "COMPILEDATE" CC:COMPILEDATE)
	      (LIST "COMPILEDBY" CC:COMPILEDBY)
	      (LIST "BLOCKMAKEDATE" (CC-RTOS (GETVAR "cdate") 2 6))
	      (LIST "WORKSTID" (GETENV "WORKSTID"))
	      (LIST "USER" (GETENV "user"))
	    )
	  )
	  (XDICTIONARY-PUT
	    BLOCK-EN
	    "CALSCRIPT"
	    (LIST (LIST "SCRIPT" LINELIST)
		  (LIST "LAMBDA" CC:LAMBDAFUNCTION)
	    )
	  )
	  (LIST BLOCK-EN)
	)
      )
    )
    (CC-NEWSET LASTENT)
  )
)

(defun c:nickshouse (/ ORIGIN CC:INSERTIONANGLE width height)
  (setvar "cmdecho" 0)
  (command "._undo" "_group")
  (if (and (or (setq ORIGIN (getpoint "\nInsertion point <(0 0 0)>: "))
	       (setq ORIGIN '(0 0 0))
	   )
	   (or (setq CC:INSERTIONANGLE
		      (getangle ORIGIN "\nInsertion angle <0>: ")
	       )
	       (setq CC:INSERTIONANGLE 0)
	   )
	   (or (setq width (getreal "\n  width <100>: "))
	       (setq width 100)
	   )
	   (or (setq height (getreal "\n  height <100>: "))
	       (setq height 100)
	   )
      )
    (nickshouse width height)
  )
  (command "._undo" "_end")
  (prin1)
)


